unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Buttons,
  DBGrids, StdCtrls, JvMemDS, DB;

type

  { TfrmTest }

  TfrmTest = class(TForm)
    btnEmptyDataset: TBitBtn;
    btnSaveToIni1: TBitBtn;
    btnPopulateTable: TBitBtn;
    btnClose: TBitBtn;
    btnSaveToFile: TBitBtn;
    btnSaveToIni: TBitBtn;
    btnLoadFromFile: TBitBtn;
    btnSetFilter: TButton;
    Button1: TButton;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    edFilter: TEdit;
    edSortBy: TEdit;
    JvMemoryData1: TJvMemoryData;
    JvMemoryData1AutoIncField1: TAutoIncField;
    JvMemoryData1BlobField1: TBlobField;
    JvMemoryData1CurrencyField1: TCurrencyField;
    JvMemoryData1DateField1: TDateField;
    JvMemoryData1DateTimeField1: TDateTimeField;
    JvMemoryData1FloatField1: TFloatField;
    JvMemoryData1IntegerField1: TLongintField;
    JvMemoryData1MemoField1: TMemoField;
    JvMemoryData1StringField1: TStringField;
    JvMemoryData1WideStringField1: TWideStringField;
    JvMemoryData1WordField1: TWordField;
    Label1: TLabel;
    StaticText1: TStaticText;
    procedure BitBtn1Click(Sender: TObject);
    procedure btnEmptyDatasetClick(Sender: TObject);
    procedure btnLoadFromFileClick(Sender: TObject);
    procedure btnSaveToIni1Click(Sender: TObject);
    procedure btnPopulateTableClick(Sender: TObject);
    procedure btnSaveToFileClick(Sender: TObject);
    procedure btnSaveToIniClick(Sender: TObject);
    procedure btnSetFilterClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmTest: TfrmTest;

implementation

uses  JvDBUtils, inifiles;

{$R *.lfm}

{ TfrmTest }

procedure TfrmTest.btnLoadFromFileClick(Sender: TObject);
begin
  if FileExists('TestFile.dat') then begin
    JvMemoryData1.LoadFromFile('TestFile.dat');
    ShowMessage('Load from filestream completed!');
  end;
end;

procedure TfrmTest.btnSaveToIni1Click(Sender: TObject);
  var IniFile:TIniFile;
begin
  IniFile := TIniFile.Create('Test.ini');
  RestoreFields(JvMemoryData1, IniFile, true);
  IniFile.Free;
  ShowMessage('Don''t think this function (from the original source code) actually does anything!');
end;

procedure TfrmTest.btnEmptyDatasetClick(Sender: TObject);
begin
  JvMemoryData1.EmptyTable;
end;

procedure TfrmTest.BitBtn1Click(Sender: TObject);
var idx:integer;
begin
  for idx := 0 to 10 do begin
    JvMemoryData1.Append;
    JvMemoryData1.FieldByName('MemoField').asString := 'New String Field....'+IntToStr(idx);
    JVMemoryData1.Post;
  end;
end;

procedure TfrmTest.btnPopulateTableClick(Sender: TObject);
var idx:integer;
begin
  JvMemoryData1.DisableControls;

  for idx := 0 to 1000 do begin
    JvMemoryData1.Append;
    JvMemoryData1.FieldByName('IntegerField').asInteger := idx;
    JvMemoryData1.FieldByName('StringField').asString := 'String Field....'+IntToStr(idx);
    JvMemoryData1.FieldByName('MemoField').asString := 'String Field....'+IntToStr(idx);
    JvMemoryData1.FieldByName('CurrencyField').asCurrency := idx * 0.5;
    JvMemoryData1.FieldByName('BlobField').AsVariant := 'String Field....'+IntToStr(idx);
    JvMemoryData1.FieldByName('DateField').asDateTime := Now + idx;
    JvMemoryData1.FieldByName('DateTimeField').asDateTime := Now + idx + 0.5;
    JvMemoryData1.FieldByName('WideStringField').asString := 'String Field....'+IntToStr(idx);
    JvMemoryData1.FieldByName('FloatField').asFloat := idx + 0.5;
    JvMemoryData1.FieldByName('WordField').asInteger := idx;
    JvMemoryData1.Post;
   end;

  JvMemoryData1.EnableControls;
end;

procedure TfrmTest.btnSaveToFileClick(Sender: TObject);
begin
  JvMemoryData1.SaveToFile('TestFile.dat');
  ShowMessage('Save to filestream completed!');
end;

procedure TfrmTest.btnSaveToIniClick(Sender: TObject);
  var IniFile:TIniFile;
begin
  IniFile := TIniFile.Create('Test.ini');
  SaveFields(JvMemoryData1, IniFile);
  IniFile.Free;
end;

procedure TfrmTest.btnSetFilterClick(Sender: TObject);
begin
  if edFilter.Text <> '' then begin
     JvMemoryData1.Filtered := False;
     JvMemoryData1.Filter := edFilter.Text;
     JvMemoryData1.Filtered := True;
  end else JvMemoryData1.Filtered := False;
end;

procedure TfrmTest.Button1Click(Sender: TObject);
begin
  if edSortBy.Text <> '' then begin
    JvMemoryData1.SortOnFields(edSortBy.Text);
  end;
end;

procedure TfrmTest.FormCreate(Sender: TObject);
begin
  JvMemoryData1.Open;
end;

end.

